;;;; s9fes-char-graphics-test.scm  -*- Scheme -*-
;;;; Kon Lovett, Jul '18

(import test)

(test-begin "S9fES Char Graphics")

;;;

(import (only (chicken port) with-output-to-string))

;;

(import (s9fes char-canvas))

(define CD-TEST-DATA-1 '(
  "##      **"
  "  ##  **  "
  "    **    "
  "  **  ##  "
  "**      ##"))

(test-group "char-canvas"
  (define (draw-test c)
    (canvas-plot-line c 0 9 9 0 #\#)
    (canvas-plot-line c 0 0 9 9 #\*)
    (canvas-dump c) )

  (let ((c (make-canvas 10 5 10 10)))

    (test-assert (canvas? c))
    (test-assert (not (canvas? 2)))

    (test 10 (canvas-width c))
    (test 5 (canvas-height c))
    (test 10 (canvas-virtual-width c))
    (test 10 (canvas-virtual-height c))

    (test "draw X example" CD-TEST-DATA-1 (draw-test c))
    (canvas-clear c)
    (test "clears" CD-TEST-DATA-1 (draw-test c)) )
)

;;

(import (s9fes char-plot))

(define CP-TEST-DATA-1 '(0 1 2 3 4 5 6 7 8 9))
;NOTE editors can trim trailing so don't give them the chance
#; ;FIXME Example Output
(define CP-TEST-RESULT-1 (apply string-append '(
"----------- foo --> -----------------\n"
"|                                 --|\n"
"|                             --X-  |\n"
"|                     --X---X-      |\n"
"|                 --X-              |\n"
"|         --X---X-                  |\n"
"|     --X-                          |\n"
"|X--X-                              |\n"
"----------- foo --> -----------------\n")))
;FIXME Actual Output
(define CP-TEST-RESULT-1 (apply string-append '(
"----------- foo --> -----------------\n"
"|                              -X   |\n"
"|                          --X-     |\n"
"|                   --X--X-         |\n"
"|                -X-                |\n"
"|         -X---X-                   |\n"
"|     --X-                          |\n"
"|X--X-                              |\n"
"----------- foo --> -----------------\n")))

(test-group "char-plot"
  (test CP-TEST-RESULT-1
        (with-output-to-string (lambda () (char-plot CP-TEST-DATA-1 'foo 7 35 #f))))
)

;;

(import (s9fes draw-tree))

(define DT-TEST-FORM-1 '((a) (b . c) (d e)))
;NOTE editors can trim trailing so don't give them the chance
(define DT-TEST-RESULT-1 (apply string-append '(
"[o|o]---[o|o]---[o|/]\n"
"  |       |       |     \n"
"[o|/]     |     [o|o]---[o|/]\n"
"  |       |       |       |     \n"
"  a       |       d       e     \n"
"          |     \n"
"        [o|o]---  c     \n"
"          |     \n"
"          b     \n"
)))

(test-group "draw-tree"
  (test DT-TEST-RESULT-1
        (with-output-to-string (lambda () (draw-tree DT-TEST-FORM-1))))
)

;;;

(test-end "S9fES Char Graphics")

(test-exit)
